<template>
    <select :id="id" class="form-select form-select-sm"
        v-model="selectedCodeId"
        @change="this.$emit('update:selectedCodeId', this.selectedCodeId)">
        <option :value="null"></option>
        <option v-for="code in codesList"
            :key="code.id"
            :value="code.id">
            {{code.number}} ({{clipp(code.name)}})
        </option>
    </select>
</template>

<script>
    export default {
        name: 'BudgetCodesDropdown',
        props: {
            id: {
                type: String,
                default: 'codes-dropdown'
            },
            codesList: Array,
            selectedCodeId: {
                required: true,
                validator: prop => typeof prop === 'number' || prop === null
            }
        },
        emits: ['update:selectedCodeId'],
        methods: {
            clipp(value) {
                if (value.length < 33)
                    return value;
                else
                    return value.substring(0, 30) + '...'
            }
        }
    }
</script>